(define make-arbre
  (lambda (etiquette fils)
    (list etiquette fils)))

(define make-feuille
  (lambda (etiquette)
    (make-arbre etiquette '())))

(define etiquette
  (lambda (a)
    (car a)))

(define fils
  (lambda (a)
    (cadr a)))

(define feuille?
  (lambda (a)
    (and (list a) (eqv? 2 (length a)) (null? (cadr a)))))

(define apply-and
  (lambda (l)
    (if (null? l)
	#t
	(and (car l) (apply-and (cdr l))))))

(define arbre?
  (lambda (o)
    (or (feuille? o)
	(and (list? o)
	     (equal? 2 (length o))
	     (apply-and (map arbre? (fils o)))))))

(define hauteur
  (lambda (a)
    (if (feuille? a)
	1
	(+ 1 (apply max (map hauteur (fils a)))))))

(define nb-feuilles
  (lambda (a)
    (if (feuille? a)
	1
	(iter (apply + (map nb-feuilles (fils a)))))))

(define nb-noeuds
  (lambda (a)
    (if (feuille? a)
	1
	(+ 1 (apply + (map nb-noeuds (fils a)))))))

(define flat-map
  (lambda (f l)
    (if (null? l)
	'()
	(append (f (car l)) (flat-map f (cdr l))))))

(define parcours-profondeur
  (lambda (a)
    (if (feuille? a)
	(list (etiquette a))
	(cons (etiquette a)
	      (flat-map parcours-profondeur (fils a))))))

(define apply-or
  (lambda (l)
    (if (null? l)
	#f
	(or (car l) (apply-or (cdr l))))))

(define recherche
  (lambda (e a)
    (if (feuille? a)
	(eqv? e (etiquette a))
	(or (eqv? e (etiquette a))
	    (apply-or (map (lambda (x) recherche e x) (fils a)))))))

(define parcours-largeur
  (lambda (a)
    (letrec
	((parcours
	  (lambda (l)
	    (if (null? l)
		'()
		(cons (etiquette (car l))
		      (parcours (append (cdr l) (fils (car l)))))))))
      (parcours (list a)))))

(define print-arbre
  (lambda (a)
    (letrec
	((ecrit-atome 
	  (lambda (dec f)
	    (cond 
	     ((= 0 dec)
	      (begin
		(write f)
		(newline)))
	     ((= 1 dec)
	      (begin
		  (display " \\--")
		  (ecrit-atome 0 f)))
	     (else (begin
		     (display "    ")
		     (ecrit-atome (- dec 1) f))))))
	 (ecrit 
	  (lambda (dec a)
	    (if (arbre? a)
		(if (feuille? a)
		    (ecrit-atome dec (etiquette a))
		    (begin
		      (ecrit-atome dec (etiquette a))
		      (for-each (lambda (x) (ecrit (+ 1 dec) x)) (fils a))))
		(ecrit-atome 0 "erreur")))))
      (ecrit 0 a))))

